#ifndef SIMWINH

#define SIMWINH

#include <owl\framewin.h>
#include <owl\gdiobjec.h>
#include <owl\applicat.h>
#include <owl\buttonga.h>
#include "thermlib.h"

#define SS_BM	3/2

#define TDELTA				16
#define TLDELTA      	37
#define TEMPDELTA			97
#define CODEDELTAPOS		165
#define CODEDELTANEG		-56
#define NAMEDELTAPOS		180
#define NAMEDELTANEG		-41

class TSimWindow : public TFrameWindow
{
	public:
		TSimWindow(TWindow*, const char*, ThermBus*,
			TButtonGadget*, TButtonGadget*, BOOL*);
		~TSimWindow();

	protected:
		void	SetupWindow();

		void	Paint( TDC&, BOOL, TRect& );
		void	PaintData( TDC& );
		void	PrintData( TDC&, int, char*, int );

		void	EvTimer(UINT);
		void	EvLButtonDown( UINT, TPoint& );
		ThermBus* SimBus;

	private:
		BOOL*	dltd;
		TButtonGadget* sw_cs_bg;
		TButtonGadget* sw_be_bg;
		TBitmap* SimBitmap;   // Main sim bitmap
		TBitmap* NewSimBitmap;
		TBitmap* AlarmBitmap;
		TFont* TempFont;
		TFont* InfoFont;
		TFont* NameFont;
		enum { _TEMPNAME_, _TEMPVAL_, _ALARMTH_, _TH_, _ALARMTL_, _TL_,
			_CODE_, _NAME_ };
		int	THhold[4];
		int	TLhold[4];

  DECLARE_RESPONSE_TABLE(TSimWindow);
};

#endif