#ifndef WIN1820H
#define WIN1820H

#define TIMER_NUM		1

#define EB_DLG					100
#define EB_MATCHROM			110
#define EB_SKIPROM			111
#define EB_ALARMSEARCH		112
#define EB_SEARCHROM			113
#define EB_READROM			114
#define EB_CONVERTT			120
#define EB_READSP				121
#define EB_WRITESP			122
#define EB_COPYSP				123
#define EB_RECALLEE			124
#define EB_READPS				125
#define EB_WRITESPTH			126
#define EB_WRITESPTL			127
#define EB_SEL_ROM_BOX		130
#define EB_LOAD_SETUP		150
#define EB_SAVE_SETUP		151
#define EB_LPT1				160
#define EB_LPT2				161
#define EB_LPT3				162
#define EB_LPT4				163
#define EB_ROMNAME			200
#define EB_ROMCODE			205
#define EB_READ_SPTLSB_D	220
#define EB_READ_SPTMSB_D 	221
#define EB_READ_SPTH_D		222
#define EB_READ_SPTL_D		223
#define EB_READ_SPUU1_D 	224
#define EB_READ_SPUU2_D 	225
#define EB_READ_SPCR_D		226
#define EB_READ_SPCP_D		227
#define EB_READ_SPCRC_D 	228
#define EB_READ_SPTLSB_H	240
#define EB_READ_SPTMSB_H	241
#define EB_READ_SPTH_H		242
#define EB_READ_SPTL_H		243
#define EB_READ_SPUU1_H		244
#define EB_READ_SPUU2_H		245
#define EB_READ_SPCR_H		246
#define EB_READ_SPCP_H		247
#define EB_READ_SPCRC_H		248
#define EB_READ_SPTLSB		260
#define EB_READ_SPTMSB		261
#define EB_READ_SPTH			262
#define EB_READ_SPTL			263
#define EB_READ_SPUU1		264
#define EB_READ_SPUU2		265
#define EB_READ_SPCR			266
#define EB_READ_SPCP			267
#define EB_READ_SPCRC		268

#define ALARM_ICON		300

#define HELP_BM		400
#define EXIT_BM		410
#define CS_SIM_BM		420
#define BUS_EXP_BM	430

#define IN_DLG			600
#define IN_ROM_CODE	610
#define IN_OLD_NAME	620
#define IN_NEW_NAME	630

#define HELP_DLG			800

#define HELP_TEXT_BOX		901
#define HELP_LIST_BOX		902
#define HELP_DUMMY_BUTTON	903

#ifndef WORKSHOP_INVOKED
#	include <owl\applicat.h>
#	include <owl\framewin.h>
#	include <owl\button.h>
#	include <owl\buttonga.h>
#	include <owl\inputdia.h>
#	include <owl\toolbox.h>
#	include <owl\listbox.h>
#	include <owl\static.h>
#	include <owl\opensave.h>
#	include <stdio.h>
#	include "thermlib.h"
#	include "simwin.h"

class TInNameDialog : public TDialog
{
	public:
		TInNameDialog( TWindow*, TResId, ThermBus*, int, char* );
		void	UpdateName( void );
		void	SetupWindow( void );

		ThermBus* InNameBus;
		int	InNameNum;
		char*	hold_text;

		DECLARE_RESPONSE_TABLE( TInNameDialog );
};

class THelpDialog : public TDialog
{
	public:
		THelpDialog( TWindow*, TResId, TButtonGadget*, BOOL* );
		void	SetupWindow( void );
		void	DisplayHelp( void );
		void	EvClose( void );
		void	EvDestroy( void );

	protected:
		BOOL*	dltd;
		TButtonGadget* hw_hlp_bg;
		void	DummyFunction( void ) {}

		DECLARE_RESPONSE_TABLE( THelpDialog );
};

class TBusDialog : public TDialog
{
	public:
		TBusDialog( TWindow*, TResId, ThermBus*,
			TButtonGadget*, TButtonGadget*, BOOL* );
		void	EvClose( void );
		void	EvPaint( void );
		void	EvDestroy( void );

	protected:
		TButtonGadget* sw_cs_bg;
		TButtonGadget* sw_be_bg;
		ThermBus* ExpBus;
		TFont* TempFont;
		BOOL	DoMatch;
		BOOL*	dltd;
		int	WhichROM;
		int	WriteTHData;
		int	WriteTLData;
		float	temperature;

		void	SetupWindow( void );

		void	SkipROM( void )
				{
				DoMatch = FALSE;
				UpdateScreen();
				}
		void	MatchROM( void )
				{
				DoMatch = TRUE;
				UpdateScreen();
				}
		void	AlarmSearch( void );
		void	SearchROM( void );
		void	ReadROM( void );

		void	ConvertT( void )
				{ DoCom( COM_CNVT_T ); }
		void	ReadSP( void )
				{ DoCom( COM_RD_SP ); }
		void	WriteSP( void );
		void	CopySP( void )
				{ DoCom( COM_CP_SP ); }
		void	RecallEE( void )
				{
				if ( ( DoCom( COM_RC_EE ) & STAT_THERM_BUSY ) == 0 )
					MessageBox( "Thermometer not busy", "Thermometer Status" );
				else
					MessageBox( "Thermometer busy", "Thermometer Status" );
				}
		void	ReadPS( void )
				{
				if ( ( DoCom( COM_RD_PS ) & STAT_PARASITE_POWER ) == 0 )
					MessageBox( "Not parasite powered", "Power Supply Status" );
				else
					MessageBox( "Parasite powered", "Power Supply Status" );
				}

		void	WriteSPTH( void );
		void	WriteSPTL( void );

		void	UpdateROMName( void );
		void	SelROM( void );

		void	CreateROMList( void );

		int	CheckInData( char* );
		int	DoCom( int com );
		void	UpdateTemp( void );
		void	UpdateScreen( void );
		void	ConvertData( uchar val, char *code, int radix );

		void	BadSetup( void );
		int	ScanData( char* );
		void	LoadSetup( void );
		void	SaveSetup( void );

		void	SetPort1( void );
		void	SetPort2( void );
		void	SetPort3( void );
		void	SetPort4( void );

		// declare the response table
		DECLARE_RESPONSE_TABLE( TBusDialog );
};

class TMainGadgetWindow : public TToolBox
{
	public:
		TMainGadgetWindow( void );
		~TMainGadgetWindow( void );
		TButtonGadget* cs_bg;
		TButtonGadget* be_bg;
		TButtonGadget* hlp_bg;

	protected:
		BOOL	del_cs;
		BOOL	del_be;
		BOOL	del_hlp;
		int	portAddr;
		TSimWindow* cs;
		TBusDialog* be;
		THelpDialog* hlp;
		ThermBus* MainBus;

		// handle the Control System Simulation button
		void	HandleControlButton( void );

		// handle the Bus Experimentation button
		void	HandleBusButton( void );

		// handle Exit menu key
		void	HandleExitButton( void )
			{ Parent->SendMessage( WM_CLOSE ); }

		// handle Help menu key
		void	HandleHelpButton( void );

		BOOL	CanClose( void );
		BOOL	SaveSetup( void );

		// declare the response table
		DECLARE_RESPONSE_TABLE(TMainGadgetWindow);
};

class TMainFrame : public TFrameWindow
{
	public:
		TMainFrame( const char* title );
};

class TMainApp : public TApplication
{
	public:
		TMainApp( void ) : TApplication()
			{}
		void	InitMainWindow( void );
};

#endif  // Resource Workshop not defined

#endif  // WIN1820H not defined
